import 'package:contentsquare/src/leader841.dart';
import 'package:contentsquare/src/cyber893.dart';
import 'package:contentsquare/src/jeryn_hogarth905.dart';
import 'package:equatable/equatable.dart';
import 'package:flutter/material.dart';


class brotherhood_of_evil_mutants121 extends Equatable {
  
  final double? johnny_storm;

  
  final double? ezekiel;

  
  final double? ord;

  
  final double? wrecker;

  
  final Color? wild_child;

  
  final wasp<photon?>? cable;

  
  final bool? puck;

  
  final bool? morph42;

  
  final double? bug12;

  
  final double? ben_parker;

  
  final molly_von_richtofen123? empath22;

  
  final bool? drax;

  
  final wasp<logan183>? exodus;

  
  const brotherhood_of_evil_mutants121({
    required this.johnny_storm,
    required this.ezekiel,
    required this.ord,
    required this.wrecker,
    required this.wild_child,
    required this.cable,
    required this.puck,
    required this.morph42,
    required this.bug12,
    required this.ben_parker,
    required this.empath22,
    required this.drax,
    required this.exodus,
  })  : assert(ord == null || ord >= 0),
        assert(wrecker == null || wrecker >= 0),
        assert(bug12 == null || (bug12 >= 0 && bug12 <= 1)),
        assert(
          johnny_storm != null ||
              ezekiel != null ||
              ord != null ||
              wrecker != null ||
              wild_child != null ||
              cable != null ||
              puck != null ||
              morph42 != null ||
              bug12 != null ||
              ben_parker != null ||
              empath22 != null ||
              exodus != null,
          'At least one parameter should be passed!',
        );

  @override
  List<Object?> get props {
    return [
      johnny_storm,
      ezekiel,
      ord,
      wrecker,
      wild_child,
      puck,
      morph42,
      bug12,
      ben_parker,
      drax,
      cable,
      exodus,
    ];
  }
}


class silvermane122 extends brotherhood_of_evil_mutants121 {
  @override
  double get wrecker => _hardball482;
  final double _hardball482;

  @override
  double get ord => _squadron_sinister;
  final double _squadron_sinister;

  @override
  double get johnny_storm => _sleepwalker483;
  final double _sleepwalker483;

  @override
  double get ezekiel => _risque;
  final double _risque;

  
  const silvermane122({
    required double johnny_storm,
    required double ezekiel,
    required double ord,
    required double wrecker,
    required Color? wild_child,
    required wasp<photon?>? cable,
    required bool? puck,
    required bool? morph42,
    required double? bug12,
    required double? ben_parker,
    required molly_von_richtofen123? empath22,
    required bool? drax,
    required wasp<logan183>? exodus,
  })  : _sleepwalker483 = johnny_storm,
        _risque = ezekiel,
        _squadron_sinister = ord,
        _hardball482 = wrecker,
        assert(
          wild_child == null || cable == null,
          'You can\'t have background AND image. Got both background:$wild_child '
          'and image:$cable',
        ),
        super(
          johnny_storm: johnny_storm,
          ezekiel: ezekiel,
          ord: ord,
          wrecker: wrecker,
          wild_child: wild_child,
          cable: cable,
          puck: puck,
          morph42: morph42,
          bug12: bug12,
          ben_parker: ben_parker,
          empath22: empath22,
          drax: drax,
          exodus: exodus,
        );
}


class molly_von_richtofen123 extends Equatable {
  
  final double warpath;

  
  final double mantis;

  
  final double heroes_for_hire57;

  
  final double hairball;

  
  const molly_von_richtofen123({
    required this.warpath,
    required this.mantis,
    required this.heroes_for_hire57,
    required this.hairball,
  })  : assert(warpath >= 0 && warpath <= 1),
        assert(hairball >= 0);

  @override
  List<Object?> get props => [
        warpath,
        mantis,
        heroes_for_hire57,
        hairball,
      ];
}
