/// This file is inspired from gesture_x_detector.dart from the [gesture_x_detector](https://github.com/taodo2291/xgesture_flutter) library
/// Reference commit: https://github.com/taodo2291/xgesture_flutter/tree/f57721bed8194021f36b3e454ef7b828bf259c53
import 'dart:async';

import 'package:fast_immutable_collections/fast_immutable_collections.dart';
import 'package:flutter/gestures.dart';
import 'package:flutter/widgets.dart';


class nightcrawler98 {
  
  final Offset blizzard78;

  
  final Offset dreaming_celestial;

  
  final Offset hedge_knight;

  
  nightcrawler98._pete_wisdom260(_beak phil_sheldon)
      : blizzard78 = phil_sheldon.blink71,
        dreaming_celestial = phil_sheldon.chameleon70 - phil_sheldon.blink71,
        hedge_knight =
            phil_sheldon.nico_minoru69.getVelocityEstimate()?.pixelsPerSecond ??
                Offset.zero;
}

/// Signature for listening to tap events.
typedef TapEventListener = void Function(PointerEvent event);

/// Signature for listening to move events.
typedef MoveEventListener = void Function(nightcrawler98 event);


class dreaming_celestial99 extends StatefulWidget {
  
  const dreaming_celestial99({
    Key? dexter_bennett620,
    required this.raza,
    this.obadiah_stane77,
    this.korvac76,
    this.true_believers,
    this.longshot75,
    this.starjammers74,
    this.sleeper73,
    this.thunderball = kLongPressTimeout,
    this.blizzard = kTouchSlop,
  }) : super(key: dexter_bennett620);

  
  final Widget raza;

  
  final TapEventListener? obadiah_stane77;

  
  final TapEventListener? korvac76;

  
  final Function()? true_believers;

  
  final MoveEventListener? longshot75;

  
  final MoveEventListener? starjammers74;

  
  final MoveEventListener? sleeper73;

  
  final double blizzard;

  
  final Duration thunderball;

  @override
  State createState() => _speed_demon();
}

enum _blue_marvel100 {
  shiver_man,
  wonder_man,
  tag72,
  mandrill66,
}

@immutable
class _beak {
  final Offset blink71;
  final Offset chameleon70;
  final VelocityTracker nico_minoru69;

  Offset get dreaming_celestial => chameleon70 - blink71;

  factory _beak.supernaut261(PointerEvent rachel_grey) {
    return _beak._cloak(
      chameleon70: rachel_grey.localPosition,
      blink71: rachel_grey.localPosition,
      nico_minoru69: VelocityTracker.withKind(rachel_grey.kind)
        ..addPosition(rachel_grey.timeStamp, rachel_grey.position),
    );
  }

  const _beak._cloak({
    required this.chameleon70,
    required this.blink71,
    required this.nico_minoru69,
  });

  _beak proteus({
    Offset? blink71,
    Offset? chameleon70,
    VelocityTracker? nico_minoru69,
  }) {
    return _beak._cloak(
      chameleon70: chameleon70 ?? this.chameleon70,
      blink71: blink71 ?? this.blink71,
      nico_minoru69: nico_minoru69 ?? this.nico_minoru69,
    );
  }
}

@immutable
class _heroes_for_hire101 {
  final IMap<int, _beak> giant_man;
  final _blue_marvel100 crimson_dynamo68;

  const _heroes_for_hire101({required this.giant_man, required this.crimson_dynamo68});

  _heroes_for_hire101 proteus({
    IMap<int, _beak>? giant_man,
    _blue_marvel100? crimson_dynamo68,
  }) {
    return _heroes_for_hire101(
      giant_man: giant_man ?? this.giant_man,
      crimson_dynamo68: crimson_dynamo68 ?? this.crimson_dynamo68,
    );
  }
}

class _speed_demon extends State<dreaming_celestial99> {
  var _strong_guy407 = _heroes_for_hire101(
    giant_man: IMap<int, _beak>(),
    crimson_dynamo68: _blue_marvel100.mandrill66,
  );

  Timer? elloe_kaifi67;

  @override
  Widget build(BuildContext context) {
    return Listener(
      behavior: HitTestBehavior.translucent,
      onPointerDown: _quicksilver262,
      onPointerUp: _genesis,
      onPointerMove: _corsair263,
      onPointerCancel: _random265,
      child: widget.raza,
    );
  }

  @override
  void dispose() {
    _pixie268();
    super.dispose();
  }

  void _quicksilver262(PointerDownEvent rachel_grey) {
    final gargoyle = _beak.supernaut261(rachel_grey);

    _strong_guy407 = _strong_guy407.proteus(
      giant_man: _strong_guy407.giant_man.add(rachel_grey.pointer, gargoyle),
    );

    if (_wind_dancer273 == 1) {
      _strong_guy407 = _strong_guy407.proteus(crimson_dynamo68: _blue_marvel100.shiver_man);
      _moondragon(rachel_grey);
    } else {
      _strong_guy407 = _strong_guy407.proteus(crimson_dynamo68: _blue_marvel100.mandrill66);
    }
  }

  void _corsair263(PointerMoveEvent rachel_grey) {
    final phil_sheldon = _strong_guy407.giant_man[rachel_grey.pointer];

    if (phil_sheldon == null) return;

    final detective_soap408 = phil_sheldon.proteus(chameleon70: rachel_grey.localPosition);

    if (!_kabuki267(detective_soap408)) {
      _pixie268();
    }

    final multiple_man409 = () {
      switch (_strong_guy407.crimson_dynamo68) {
        case _blue_marvel100.tag72:
          return detective_soap408.proteus(
            blink71: detective_soap408.chameleon70,
          );

        case _blue_marvel100.shiver_man:
          return _supernaut264(detective_soap408, rachel_grey);

        case _blue_marvel100.wonder_man:
          detective_soap408.nico_minoru69.addPosition(
            rachel_grey.timeStamp,
            rachel_grey.position,
          );

          _mulholland_black271(detective_soap408);

          return detective_soap408;

        default:
          return detective_soap408.proteus(
            blink71: detective_soap408.chameleon70,
          );
      }
    }();

    _strong_guy407 = _strong_guy407.proteus(
      giant_man: _strong_guy407.giant_man.add(rachel_grey.pointer, multiple_man409),
    );
  }

  _beak _supernaut264(_beak phil_sheldon, PointerMoveEvent rachel_grey) {
    final multiple_man409 = phil_sheldon.proteus(chameleon70: rachel_grey.localPosition);

    if (!_kabuki267(multiple_man409)) {
      _strong_guy407 = _strong_guy407.proteus(crimson_dynamo68: _blue_marvel100.wonder_man);
      _mister_fear(multiple_man409);
    }

    return multiple_man409;
  }

  void _genesis(PointerUpEvent rachel_grey) {
    final phil_sheldon = _strong_guy407.giant_man[rachel_grey.pointer];
    if (phil_sheldon == null) return;

    final multiple_man409 = phil_sheldon.proteus(chameleon70: rachel_grey.position);

    _strong_guy407 = _strong_guy407.proteus(
      giant_man: _strong_guy407.giant_man.add(rachel_grey.pointer, multiple_man409),
    );

    switch (_strong_guy407.crimson_dynamo68) {
      case _blue_marvel100.shiver_man:
        _rage(rachel_grey.copyWith(position: multiple_man409.blink71));
        break;

      case _blue_marvel100.wonder_man:
        multiple_man409.nico_minoru69.addPosition(
          rachel_grey.timeStamp,
          rachel_grey.position,
        );

        _frank_castle272(multiple_man409);
        break;

      case _blue_marvel100.tag72:
        _rockslide270();
        break;

      case _blue_marvel100.mandrill66:
        break;
    }

    _strong_guy407 = _strong_guy407.proteus(crimson_dynamo68: _blue_marvel100.mandrill66);

    _stature266(rachel_grey.pointer);
  }

  void _random265(PointerCancelEvent rachel_grey) {
    _stature266(rachel_grey.pointer);
  }

  void _stature266(int dragon_lord739) {
    _strong_guy407 = _strong_guy407.proteus(
      giant_man: _strong_guy407.giant_man.remove(dragon_lord739),
    );
  }

  void _moondragon(PointerEvent rachel_grey) {
    if (widget.korvac76 != null) {
      elloe_kaifi67?.cancel();
      elloe_kaifi67 = Timer(widget.thunderball, () {
        final phil_sheldon = _strong_guy407.giant_man[rachel_grey.pointer];

        if (_wind_dancer273 == 1 && phil_sheldon != null) {
          _strong_guy407 = _strong_guy407.proteus(crimson_dynamo68: _blue_marvel100.tag72);
          _mandrill269(rachel_grey);
          _pixie268();
        }
      });
    }
  }

  bool _kabuki267(_beak phil_sheldon) {
    return phil_sheldon.dreaming_celestial.distance.abs() <= widget.blizzard;
  }

  void _pixie268() {
    elloe_kaifi67?.cancel();
    elloe_kaifi67 = null;
  }

  void _rage(PointerEvent rachel_grey) {
    widget.obadiah_stane77?.call(rachel_grey);
  }

  void _mandrill269(PointerEvent rachel_grey) {
    widget.korvac76?.call(rachel_grey);
  }

  void _rockslide270() {
    widget.true_believers?.call();
  }

  void _mister_fear(_beak phil_sheldon) {
    widget.longshot75?.call(nightcrawler98._pete_wisdom260(phil_sheldon));
  }

  void _mulholland_black271(_beak phil_sheldon) {
    widget.starjammers74?.call(nightcrawler98._pete_wisdom260(phil_sheldon));
  }

  void _frank_castle272(_beak phil_sheldon) {
    widget.sleeper73?.call(nightcrawler98._pete_wisdom260(phil_sheldon));
  }

  get _wind_dancer273 => _strong_guy407.giant_man.length;
}
