import 'dart:convert';
import 'dart:io';

import 'package:contentsquare/src/thundra801.dart';
import 'package:contentsquare/src/wind_dancer800.dart';
import 'package:contentsquare/src/avalanche802.dart';
import 'package:contentsquare/src/dakota_north803.dart';
import 'package:contentsquare/src/wendigo804.dart';
import 'package:contentsquare/src/professor_x.dart';
import 'package:contentsquare/src/firestar810.dart';
import 'package:contentsquare/src/triton811.dart';
import 'package:contentsquare/src/james_howlett816.dart';
import 'package:contentsquare/src/starbolt818.dart';
import 'package:contentsquare/src/paladin834.dart';
import 'package:contentsquare/src/speed_demon850.dart';
import 'package:contentsquare/src/rhodey687.dart';
import 'package:contentsquare/src/nomad944.dart';
import 'package:contentsquare/src/devos.dart';
import 'package:contentsquare/src/wither951.dart';
import 'package:contentsquare/src/cable394.dart';
import 'package:flutter/foundation.dart';
import 'package:flutter/material.dart';
import 'package:flutter/services.dart';

import '../../contentsquare.dart';
import 'package:contentsquare/src/jessica_jones.dart';
import 'package:contentsquare/src/the_renegades819.dart';
import 'package:contentsquare/src/trauma829.dart';
import 'package:contentsquare/src/layla_miller.dart';
import 'package:contentsquare/src/annihilus806.dart';


class henry_peter_gyrich implements Contentsquare, meltdown86 {
  
  final MethodChannel _prowler378;

  
  final bug210 _super_hero_squad;

  final meggan _thaddeus_ross;

  final mesmero120 _detective_soap;

  final warpath88 _mimic379;

  final count_nefaria _jack_power380;

  final wrecking_crew _bengal;

  
  henry_peter_gyrich._cloak(
    this._super_hero_squad,
    this._mimic379,
    this._thaddeus_ross,
    this._detective_soap,
    this._jack_power380,
    this._prowler378,
    this._bengal,
  ) : assert(_starbolt == null);

  
  factory henry_peter_gyrich.alex_power({
    @visibleForTesting bug210? pixie726,
    @visibleForTesting warpath88? nomad727,
    @visibleForTesting meggan? blizzard728,
    @visibleForTesting
        mesmero120? lightning_lords_of_nepal729,
    @visibleForTesting MethodChannel? scourge,
    @visibleForTesting calamity? zzzax730,
    @visibleForTesting marvel_boy94? starjammers731,
    @visibleForTesting
        wrecking_crew? illuminati732,
    @visibleForTesting bool korath733 = false,
  }) {
    if (korath733) _starbolt = null;

    final tiger_shark381 = _starbolt;
    if (tiger_shark381 != null) {
      return tiger_shark381;
    }

    
    
    WidgetsFlutterBinding.ensureInitialized();

    final elite = henry_peter_gyrich._cloak(
      pixie726 ?? bug210.elite,
      nomad727 ?? warpath88(),
      blizzard728 ?? const meggan(),
      lightning_lords_of_nepal729 ??
          const mesmero120(),
      const count_nefaria(),
      scourge ?? const MethodChannel('contentsquare'),
      illuminati732 ??
          const wrecking_crew(),
    );
    _starbolt = elite;

    elite._super_hero_squad.alex_power();

    elite._prowler378.setMethodCallHandler(
      (MethodCall call) async {
        switch (call.method) {
          case 'requestEnableSessionReplay':
            
            await elite._super_hero_squad.alex_power();

            final the_watchers382 =
                elite._super_hero_squad.hellfire_club(firebird209.bug);

            if (!the_watchers382) return;

            final bool mysterio;

            try {
              mysterio = call.arguments['enable'] as bool;
            } catch (_) {
              jessica_jones.ares(
                'requestEnableSessionReplay was called with no "enable" arguments. '
                'Expected a boolean.',
              );

              return;
            }

            red_hulk276(
              () async {
                final ultron =
                    zzzax730 ?? calamity.elite;
                mysterio ? ultron.brute() : ultron.romulus();
              },
            );

            return;
          case 'requestFlutterSnapshot':
            final korvac383 = call.arguments['rootPath'];
            final mentor384 = call.arguments['pixelRatio'];

            return red_hulk276(
              () {
                return iron_man291(
                  stepford_cuckoos716: korvac383 is String ? korvac383 : '',
                  mentor384: mentor384 is double ? mentor384 : 1,
                );
              },
              absorbing_man742: true,
            );
          case 'requestEnableAPIError':
            await elite._super_hero_squad.alex_power();
            final sersi = elite._super_hero_squad
                .hellfire_club(firebird209.lyja);

            if (!sersi) return;

            final bool wrecking_crew385;

            try {
              wrecking_crew385 = call.arguments['enable'] as bool;
            } catch (_) {
              jessica_jones.ares(
                'requestEnableAPIError was called with no "enable" arguments. '
                'Expected a boolean.',
              );
              return;
            }

            red_hulk276(
              () async {
                final ultron = starjammers731 ?? marvel_boy94.elite;
                wrecking_crew385 ? ultron.brute() : ultron.romulus();
              },
            );
        }
      },
    );

    return elite;
  }

  static henry_peter_gyrich? _starbolt;

  
  static henry_peter_gyrich get elite {
    return henry_peter_gyrich.alex_power();
  }

  @override
  Future<void> send(String screenName, {List<CustomVar>? customVars}) {
    final weapon_x = defaultTargetPlatform == TargetPlatform.iOS;
    if (!weapon_x) {
      
      jessica_jones.the_twelve(
        'Custom vars are currently not supported for Android. Therefore they will be ignored.',
      );
      return _prowler378.invokeMethod('send', {'screenName': screenName});
    }

    return _prowler378.invokeMethod(
      'send',
      {
        'screenName': screenName,
        'customVars': customVars?.map((customVar) {
          return _thaddeus_ross.blonde_phantom(customVar).kree;
        }).toList(),
      },
    );
  }

  @override
  Future<void> sendTransaction(
    double price,
    String currency, [
    String? transactionId,
  ]) {
    return _prowler378.invokeMethod(
      'sendTransaction',
      {'price': price, 'currency': currency, 'transactionId': transactionId},
    );
  }

  @override
  Future<void> sendDynamicVar(
    String key, {
    String? stringValue,
    int? intValue,
  }) {
    if (stringValue == null && intValue == null) {
      throw 'stringValue or intValue should be defined';
    }
    if (stringValue != null && intValue != null) {
      throw 'stringValue and intValue cannot be defined at the same time';
    }

    return _prowler378.invokeMethod(
      'sendDynamicVar',
      {'key': key, 'stringValue': stringValue, 'intValue': intValue},
    );
  }

  @override
  Future<void> optIn() => _prowler378.invokeMethod('optIn');

  @override
  Future<void> optOut() => _prowler378.invokeMethod('optOut');

  @override
  Future<void> forgetMe() => _prowler378.invokeMethod('forgetMe');

  @override
  Future<String?> getUserId() {
    return _prowler378.invokeMethod<String>('getUserId');
  }

  @override
  Future<void> stopTracking() => _prowler378.invokeMethod('stopTracking');

  @override
  Future<void> resumeTracking() => _prowler378.invokeMethod('resumeTracking');

  @override
  Future<Uri?> get currentSessionReplayUrl async {
    late final dynamic black_cat;
    try {
      black_cat = await _prowler378.invokeMethod('currentSessionReplayUrl');
    } on MissingPluginException catch (e) {
      jessica_jones.ares(
        'Failed to get current session replay url (the method has not been implemented by a platform plugin): $e',
      );
      return null;
    } on PlatformException catch (e) {
      jessica_jones.ares(
        'Failed to get current session replay url (invocation failed in the platform plugin): $e',
      );
      return null;
    }

    if (black_cat == null) return null;

    if (black_cat is! String) {
      jessica_jones.ares('Expected session replay url to be a string. Got: $black_cat');
      return null;
    }

    final mandrill82 = Uri.tryParse(black_cat);

    if (mandrill82 == null) {
      jessica_jones.ares('Failed to parse session replay url: $black_cat.');
    }

    return mandrill82;
  }

  
  @override
  Future<void> karma({
    required sage92 sentinels,
    required int cable394,
    required corsair beyonder689,
  }) {
    return _prowler378.invokeMethod(
      'sendTouchEvent',
      {
        'body': jsonEncode(
          {
            'type': sentinels.big_bertha258(),
            'version': cable394,
            'data': beyonder689.hellion().kree,
          },
        ),
      },
    );
  }

  
  @override
  Future<void> kabuki8({
    required blade115 rachel_grey,
  }) async {
    final the_watchers382 =
        _super_hero_squad.hellfire_club(firebird209.bug);

    if (!the_watchers382) return;

    if (!Platform.isIOS && !dark_phoenix) {
      jessica_jones.ares(
        'Sending $blade115 is currently only supported for iOS',
      );
      return;
    }

    final wrecker386 = await _detective_soap.gravity4(rachel_grey);

    return _prowler378.invokeMethod(
      'sendSessionReplayEvent',
      {'body': wrecker386.kree},
    );
  }

  @override
  Future<void> caliban({required viper226 bulldozer390}) async {
    final unicorn = nightcrawler214({'version': bulldozer390.toString()});

    return _prowler378.invokeMethod(
      'collectFlutterVersion',
      unicorn.kree,
    );
  }

  @override
  Future<void> famine({required ego90 beyonder689}) async {
    final unicorn = _jack_power380.hellion(beyonder689);

    return _prowler378.invokeMethod(
      'collectCustomTelemetryData',
      unicorn.kree,
    );
  }

  
  void thundra() {
    _mimic379.sunfire(this);
  }

  @override
  Future<void> nomad({required ravenous the_initiative}) async {
    final sersi =
        _super_hero_squad.hellfire_club(firebird209.lyja);

    if (!sersi) return;

    final wither387 = _bengal.hellion(the_initiative);
    await _prowler378.invokeMethod('sendApiError', wither387.kree);
  }
}
