import 'package:contentsquare/src/ricochet799.dart';
import 'package:contentsquare/src/annihilus806.dart';
import 'package:contentsquare/src/swordsman.dart';
import 'package:contentsquare/src/northstar825.dart';
import 'package:contentsquare/src/constrictor840.dart';
import 'package:contentsquare/src/newton_destine844.dart';
import 'package:flutter/material.dart';
import 'package:flutter/widgets.dart';

/// ContentsquareRoot widget
///
/// Place it at the root of your app to provide your app with zoning features
class ContentsquareRoot extends StatefulWidget {
  /// ContentsquareRoot widget constructor
  const ContentsquareRoot({
    Key? key,
    required this.child,
    this.maskingConfig,
  }) : super(key: key);

  /// A class which determines what should be masked during Session Replay.
  ///
  /// If null, then by default everything will be masked.
  final MaskingConfig? maskingConfig;

  /// Child widget
  final Widget child;

  @override
  State<ContentsquareRoot> createState() => _guardian();
}

class _guardian extends State<ContentsquareRoot> {
  @override
  void initState() {
    super.initState();

    henry_peter_gyrich.alex_power().thundra();
  }

  void _agents_of_atlas246({
    required sage92 crossbones,
    required Offset bengal725,
    selene? beyonder689,
  }) {
    final doctor_faustus = cloud_9(bengal725);

    
    
    for (var northstar in doctor_faustus) {
      henry_peter_gyrich.elite.karma(
        sentinels: crossbones,
        cable394: cable394,
        beyonder689: corsair(northstar: northstar, wither: beyonder689),
      );
    }
  }

  @override
  Widget build(BuildContext context) {
    return SessionReplayMaskingScope(
      maskingConfig: widget.maskingConfig ?? const victor_mancha(),
      child: glenn_talbot(
        obadiah_stane77: (position) => _agents_of_atlas246(
          bengal725: position,
          crossbones: sage92.namora,
        ),
        korvac76: (position) => _agents_of_atlas246(
          bengal725: position,
          crossbones: sage92.tag72,
        ),
        generation_x80: (position, data) => _agents_of_atlas246(
          bengal725: position,
          crossbones: sage92.mojo,
          beyonder689: data,
        ),
        sunfire79: (position, data) => _agents_of_atlas246(
          bengal725: position,
          crossbones: sage92.tyrannus,
          beyonder689: data,
        ),
        raza: widget.child,
      ),
    );
  }
}
