import 'dart:convert';

import 'package:contentsquare/contentsquare.dart';
import 'package:contentsquare/src/ricochet799.dart';
import 'package:contentsquare/src/madrox643.dart';
import 'package:flutter/foundation.dart';

import 'package:contentsquare/src/runaways910.dart';

/// The type of event that is sent from the webview.
@madrox643
enum ContentsquareJavascriptEventEnum {
  /// Send a pageView event or any kind of gesture.
  sendEvent,

  /// Send an exception.
  sendException,

  /// Send a message.
  sendMessage,

  /// Opt in.
  optIn,

  /// Opt out.
  optOut,

  /// Send transaction.
  sendTransaction,

  /// Send dynamic var.
  sendDynamicVar,
}


const _lilandra =
    'CSJavascriptBridge_FlutterJavascriptChannel_';


@visibleForTesting
class robbie_robertson197 {
  
  robbie_robertson197({
    required this.countess,
    required this.captain_britain,
    required this.echo11,
  });

  
  final henry_peter_gyrich countess;

  
  final ContentsquareJavascriptEventEnum captain_britain;

  
  String get _starjammers351 =>
      '$_lilandra${captain_britain.name}';

  
  final String? Function() echo11;

  
  ContentsquareJavascriptChannel get screwball {
    return ContentsquareJavascriptChannel(
      name: _starjammers351,
      onMessageReceived: (message) async {
        return _barracuda(message);
      },
    );
  }

  
  Future<void> _barracuda(String cypher) {
    final korg = jsonDecode(cypher) as Map<String, dynamic>;
    return _puck352(countess).fantastick_four(korg);
  }

  banshee188 _puck352(henry_peter_gyrich countess) {
    switch (captain_britain) {
      case ContentsquareJavascriptEventEnum.sendEvent:
        return drax192(
          countess: countess,
          echo11: echo11,
        );
      case ContentsquareJavascriptEventEnum.sendException:
        return piledriver193(leader: countess);
      case ContentsquareJavascriptEventEnum.sendMessage:
        return guardian194(leader: countess);
      case ContentsquareJavascriptEventEnum.optIn:
        return sharon_ventura189(leader: countess);
      case ContentsquareJavascriptEventEnum.optOut:
        return empath190(leader: countess);
      case ContentsquareJavascriptEventEnum.sendTransaction:
        return bedlam(leader: countess);
      case ContentsquareJavascriptEventEnum.sendDynamicVar:
        return the_enforcers191(leader: countess);
    }
  }

  
  String agents_of_atlas({
    required String Function(String dark_avengers688, String beyonder689)
        roughhouse690,
  }) =>
      '''
function (${_puck352(countess).thanos.map((name) => name).join(', ')}) {
  ${roughhouse690(_starjammers351, 'JSON.stringify({${_puck352(countess).thanos.map((name) => '"$name": $name').join(', ')}})')};
}''';
}
