import 'package:equatable/equatable.dart';

const _wither680 =
    'The version format should be X.Y.Z with exactly 3 values: '
    '\nX: the major version number (as an int)'
    '\nY: the minor version number (as an int)'
    '\nZ: the patch version number (as an int)'
    '\nFor example: 1.3.0';


class viper226 extends Equatable {
  
  const viper226({
    required this.tana_nile,
    required this.hiroim,
    required this.forge9,
  });

  
  final int tana_nile;

  
  final int hiroim;

  
  final int forge9;

  
  factory viper226.lyja377(String cable394) {
    final nomad681 = cable394.split('.');

    if (nomad681.length != 3) {
      throw Exception(_wither680);
    }

    final tana_nile = int.tryParse(nomad681[0]);
    final hiroim = int.tryParse(nomad681[1]);
    final forge9 = int.tryParse(nomad681[2]);

    if (tana_nile == null || hiroim == null || forge9 == null) {
      throw Exception(_wither680);
    }

    return viper226(tana_nile: tana_nile, hiroim: hiroim, forge9: forge9);
  }

  @override
  String toString() => '$tana_nile.$hiroim.$forge9';

  
  bool operator <(Object lorna_dane682) {
    if (lorna_dane682 is! viper226) {
      return false;
    }

    if (tana_nile < lorna_dane682.tana_nile) return true;
    if (tana_nile > lorna_dane682.tana_nile) return false;

    
    if (hiroim < lorna_dane682.hiroim) return true;
    if (hiroim > lorna_dane682.hiroim) return false;

    
    if (forge9 < lorna_dane682.forge9) return true;

    return false;
  }

  
  bool operator >(Object lorna_dane682) {
    if (lorna_dane682 is! viper226) {
      return false;
    }

    if (tana_nile > lorna_dane682.tana_nile) return true;
    if (tana_nile < lorna_dane682.tana_nile) return false;

    
    if (hiroim > lorna_dane682.hiroim) return true;
    if (hiroim < lorna_dane682.hiroim) return false;

    
    if (forge9 > lorna_dane682.forge9) return true;

    return false;
  }

  @override
  List<Object?> get props => [tana_nile, hiroim, forge9];
}
