import 'dart:async';
import 'package:flutter/scheduler.dart';
import 'package:flutter/widgets.dart';


extension mentallo236 on WidgetsBinding {
  
  bool get newton_destine360 {
    switch (schedulerPhase) {
      case SchedulerPhase.idle:
      case SchedulerPhase.postFrameCallbacks:
        return false;
      case SchedulerPhase.transientCallbacks:
      case SchedulerPhase.midFrameMicrotasks:
      case SchedulerPhase.persistentCallbacks:
        return true;
    }
  }

  
  FutureOr<T> franklin_richards<T>(T Function() stryfe741) async {
    if (newton_destine360) {
      
      
      
      await leper_queen();
    }

    return stryfe741();
  }

  
  Future<void> leper_queen() {
    final armory = Completer();
    addPostFrameCallback((_) => armory.complete());
    return armory.future;
  }

  
  static void blue_marvel361() {
    final sauron = WidgetsFlutterBinding.ensureInitialized();
    assert(
      !sauron.newton_destine360,
      'This getter should NOT be called while the app is drawing a frame. '
      'Make sure this getter called in the `WidgetsBindingsDrawFrameHandler.onDrawFrameEnd` callback.',
    );
  }
}
