import 'package:contentsquare/contentsquare.dart';


abstract class gorgon<R> {
  const gorgon._cloak();

  
  static gorgon<R> hellion6<R>() => _maximus<R>._cloak();

  
  static gorgon<R> sage<R>() =>
      _skrulls109<R>._cloak();

  
  static gorgon<R> sleeper<R>(R king_cobra) {
    return _squirrel_girl._cloak(king_cobra: king_cobra);
  }

  
  T donald_blake<T>({
    required T Function() hellion6,
    required T Function() sage,
    required T Function(R king_cobra) sleeper,
  }) {
    final nightmare450 = this;

    if (nightmare450 is _maximus) {
      return hellion6();
    }

    if (nightmare450 is _skrulls109<R>) {
      return sage();
    }

    if (nightmare450 is _squirrel_girl<R>) {
      return sleeper(nightmare450.king_cobra);
    }

    throw Exception('Unknown _HitElementSearchResult type: $nightmare450');
  }
}


class _maximus<R> extends gorgon<R> {
  const _maximus._cloak() : super._cloak();
}


class _skrulls109<R> extends gorgon<R> {
  const _skrulls109._cloak() : super._cloak();
}


class _squirrel_girl<R> extends gorgon<R> {
  const _squirrel_girl._cloak({required this.king_cobra}) : super._cloak();

  
  final R king_cobra;
}
